<!doctype html>
<html>
	<head>
		<meta charset="utf-8">
		<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">

		<title>Advanced</title>

		<link rel="icon" type="image/png" href="images/org_symbol.png" />
		<link rel="stylesheet" href="css/reset.css">
		<link rel="stylesheet" href="css/reveal.css">
		<link rel="stylesheet" href="css/theme/black.css" id="theme">

		<!-- Theme used for syntax highlighting of code -->
		<link rel="stylesheet" href="lib/css/monokai.css">

		<!-- Printing and PDF exports -->
		<script>
			var link = document.createElement( 'link' );
			link.rel = 'stylesheet';
			link.type = 'text/css';
			link.href = window.location.search.match( /print-pdf/gi ) ? 'css/print/pdf.css' : 'css/print/paper.css';
			document.getElementsByTagName( 'head' )[0].appendChild( link );
		</script>
	</head>
	<body>
		<div style="background:green; left:0; right:0; position:absolute; height:30px;">
			<div style="text-align: center;">(U)Unclassified</div>
		</div>

		<div class="reveal">
			<div class="slides">
				<section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h1>Advanced Topics</h1>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>Advanced Topics Overview</h3>
						<ul>
							<li><b>CTypes and Structures</b></li>
							<li><b>Regex</b></li>
							<li><b>Additional Libraries and Modules</b></li>
							<li><b>Multithreading</b></li>
							<li><b>Unit Testing</b></li>
							<li><b>Metaclasses</b></li>
						</ul>
					</section>
					<section>
					    <h2>Objectives</h2>
					    <a href="../objectives.html" target="_blank">Advanced Topics Objectives</a>
					</section>
				</section>
				<section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h2>CTypes and Structures</h2>
						<p>
							CTypes provide C compatible data types and allow function calls from DLLs or shared libraries without having to write custom C extensions for every operation. 
						</p>
						<p><b>CTypes are a Foreign Function Interface (FFI) library and provide an API for creating C-compatible datatypes.</b></p>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h4>Loading Libraries</h4>
						<ul>
							<li>There are four types of dynamic library loaders available in ctypes and two conventions to use them.
								<ul>
									<li>The classes that represent dynamic and shared libraries are ctypes.</li>
									<li>CDLL, ctypes</li>
									<li>PyDLL, ctypes</li>
									<li>OleDLL, and ctypes</li>
									<li>WinDLL</li>
								</ul>
							</li>
						</ul>
							<!--
							Instructor Note
							The last two are only available on Windows.
							-->	
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h4>Differences between CDLL and PyDLL:</h4>
						<ul>
							<li style="font-size: 30px;">ctypes.CDLL:
								<ul>
									<li>This class represents loaded shared libraries</li>
									<li>The functions in these libraries use the standard calling convention, and are assumed to return int</li>
									<li>GIL (Global Interpreter Lock) is released during the call. (More on GIL)</li>
								</ul>
							</li>
							<li style="font-size: 30px;">ctypes.PyDLL: 
								<ul>
									<li>This class works like CDLL, but GIL is not released during the call</li>
									<li>After execution, the Python error flag is checked and an exception is raised if it is set</li>
									<li>It is only useful when directly calling functions from the Python/C API</li>
								</ul>
							</li>
						</ul>
					</section>
					<section>
						<h4>CDLL vs. PyDLL (Cont.)</h4>
						<p style="font-size: 30px;">To load a library, you can either instantiate one of the preceding classes with proper arguments or call the LoadLibrary() function from the submodule associated with a specific class:</p>
						<ul style="font-size: 30px;">
							<li>ctypes.cdll.LoadLibrary() for ctypes.CDLL</li>
							<li>ctypes.pydll.LoadLibrary() for ctypes.PyDLL</li>
							<li>ctypes.windll.LoadLibrary() for ctypes.WinDLL</li>
							<li>ctypes.oledll.LoadLibrary() for ctypes.OleDLL</li>
						</ul>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p>
							Both library loading conventions (the LoadLibrary() function and specific library-type classes) require you to use the full library name. 
							This means all the predefined library prefixes and suffixes need to be included. For example, to load the C standard library on Linux, you need to write the following:
						</p>

					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>CTypes Import</h3>
						<pre>
<code data-trim data-noescape>
>>> import ctypes
>>> ctypes.cdll.LoadLibrary('libc.so.6')
&lt;CDLL 'libc.so.6', handle 7f0603e5f000 at 7f0603d4cbd0&gt;


>>> import ctypes
>>> from ctypes.util import find_library
>>> ctypes.cdll.LoadLibrary(find_library('c'))
&lt;CDLL '/usr/lib/libc.dylib', handle 7fff69b97c98 at 0x101b73ac8&gt;
>>> ctypes.cdll.LoadLibrary(find_library('bz2'))
&lt;CDLL '/usr/lib/libbz2.dylib', handle 10042d170 at 0x101b6ee80&gt;
>>> ctypes.cdll.LoadLibrary(find_library('AGL'))
&lt;CDLL '/System/Library/Frameworks/AGL.framework/AGL', handle 101811610 at 0x101b73a58&gt;                                                                                      
</code>
						</pre>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h4>Calling C functions using ctypes</h4>
						<pre>
<code data-trim data-noescape>
>>> import ctypes
>>> from ctypes.util import find_library
>>> 
>>> libc = ctypes.cdll.LoadLibrary(find_library('c'))
>>> 
>>> libc.printf(b"Hello world!\n")
Hello world!
</code>
						</pre>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h4>Data Types</h4>
						<p>Unfortunately, all the built-in Python types except integers, strings, and bytes are incompatible with C datatypes and thus must be wrapped in the corresponding classes provided by the ctypes module.</p>
						<table>
							<tr>
								<th>ctypes type</th>
								<th>C type</th>
								<th>Python</th>
							</tr>
							<tr style="font-size: 24px;">
								<td>c_bool</td>
								<td>_Bool</td>
								<td>bool (1)</td>
							</tr>
							<tr style="font-size: 24px;">
								<td>c_char</td>
								<td>char</td>
								<td>1-character bytes object</td>
							</tr>
							<tr style="font-size: 24px;">
								<td>c_wchar</td>
								<td>wchar_t</td>
								<td>1-character string</td>
							</tr>
							<tr style="font-size: 24px;">
								<td>c_byte</td>
								<td>char</td>
								<td>int</td>
							</tr>
							<tr style="font-size: 24px;">
								<td>c_ubyte</td>
								<td>unsigned char</td>
								<td>int</td>
							</tr>
							
						</table>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<table>
							<tr>
								<th>ctypes type</th>
								<th>C type</th>
								<th>Python</th>
							</tr>
							<tr style="font-size: 24px;">
								<td>c_short</td>
								<td>short</td>
								<td>int</td>
							</tr>
							<tr style="font-size: 24px;">
								<td>c_ushort</td>
								<td>unsigned short</td>
								<td>int</td>
							</tr>
							<tr style="font-size: 24px;">
								<td>c_int</td>
								<td>int</td>
								<td>int</td>
							</tr>
							<tr style="font-size: 24px;">
								<td>c_uint</td>
								<td>unsigned int</td>
								<td>int</td>
							</tr>
							<tr style="font-size: 24px;">
								<td>c_long</td>
								<td>long</td>
								<td>int</td>
							</tr>
							<tr style="font-size: 24px;">
								<td>c_ulong</td>
								<td>unsigned long</td>
								<td>int</td>
							</tr>
							<tr style="font-size: 24px;">
								<td>c_longlong</td>
								<td>__int64 or long long</td>
								<td>int</td>
							</tr>
							<tr style="font-size: 24px;">
								<td>c_ulonglong</td>
								<td>unsigned __int64 or unsigned long long</td>
								<td>int</td>
							</tr>
							<tr style="font-size: 24px;">
								<td>c_size_t</td>
								<td>size_t</td>
								<td>int</td>
							</tr>
							
						</table>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<table>
							<tr>
								<th>ctypes type</th>
								<th>C type</th>
								<th>Python</th>
							</tr>
							<tr style="font-size: 24px;">
								<td>c_ssize_t</td>
								<td>ssize_t or Py_ssize_t</td>
								<td>int</td>
							</tr>
							<tr style="font-size: 24px;">
								<td>c_float</td>
								<td>float</td>
								<td>float</td>
							</tr>
							<tr style="font-size: 24px;">
								<td>c_double</td>
								<td>double</td>
								<td>float</td>
							</tr>
							<tr style="font-size: 24px;">
								<td>c_longdouble</td>
								<td>long double</td>
								<td>float</td>
							</tr>
							<tr style="font-size: 24px;">
								<td>c_char_p</td>
								<td>char * (NUL terminated)</td>
								<td>bytes object or None</td>
							</tr>
							<tr style="font-size: 24px;">
								<td>c_wchar_p</td>
								<td>wchar_t * (NUL terminated)</td>
								<td>string or None</td>
							</tr>
							<tr style="font-size: 24px;">
								<td>c_void_p</td>
								<td>void *</td>
								<td>int or None</td>
							</tr>
						</table>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p>
							As you can see, this table does not contain dedicated types that would reflect any of the Python collections as C arrays. The recommended way to create types for C arrays is to simply use the multiplication operator with the desired basic ctypes type:
						</p>
						<pre>
							<code data-trim data-noescape>
								>>> import ctypes
								>>> IntArray5 = ctypes.c_int * 5
								>>> c_int_array = IntArray5(1, 2, 3, 4, 5)
								>>> FloatArray2 = ctypes.c_float * 2
								>>> c_float_array = FloatArray2(0, 3.14)
								>>> c_float_array[1]
								3.140000104904175																																														
							</code>
						</pre>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h4>Defining Argument Types and Return Types</h4>
						<p>If a C library requires arguments to be passed and/or has a return value, it is a good practice to declare them like so:</p>
						<pre>
<code data-trim data-noescape>
import ctypes


calc = ctypes.CDLL("MyCalc.dll")
addition = calc.addition()
# Declare return type
addition.restype = ctypes.c_int
# Declare argument types
addition.argtypes = [ctypes.c_int, ctypes.c_int]
# Pass arguments
addition(1,2)																																												
</code>
						</pre>
					</section>
				</section>
				<section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h4>Structures</h4>
						<p style="font-size: 24px;">
							Creating C Structs in Python can be useful. For instance, let's assume a function within a DLL requires a pointer to a struct to be passed. 
							A real world example of this would be a DLL file that communicates with hardware. Below is an example of how to create a C struct using Python ctypes
						</p>
						<pre>
<code data-trim data-noescape>
import ctypes

# Create the struct
class P_Struct(ctypes.Structure):
    _fields_ = [("field_1", ctypes.c_int),
                ("field_2", ctypes.c_char_p)]

# Pass struct values                 
my_struct = P_Struct(1, "Hello World")
# Create a pointer to my_struct
pointer_my_struct = ctypes.pointer(my_struct)

print my_struct.field_1, my_struct.field_2

# Import the DLL and pass pointer_my_struct to the C function requiring a pointer to a struct.                                                                                                                                                                           
</code>
						</pre>
						<p style="font-size: 24px;"><b>Output:</b></p>
						<pre>
<code data-trim data-noescape>
Hello World																																									
</code>
						</pre>
					</section>
				</section>
				<section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h2>Regular Expressions</h2>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h4>Using Regular Expessions</h4>
						<ul>
							<li><b>re.compile:</b> compiles regular expression into pattern objects which allows for repeated use</li>
							<li><b>re.match:</b> apply pattern to the start of a string, return match or None</li>
							<li><b>re.search:</b> scan through a string, return match or None</li>
							<li><b>re.findall:</b> find all matches and return them as a list</li>
						</ul>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h4>Python re search and compile example:</h4>
						<pre>
<code data-trim data-noescape>
import re

search_str = "This is a string to search"
re_search = re.compile("string")
matched_obj = re_search.search(search_str)

print(matched_obj)
</code>
						</pre>
						<pre>
<code data-trim data-noescape>
&lt;_sre.SRE_Match object at 0x02CBFA68&gt;
</code>
						</pre>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h4>Practical Example</h4>
						<pre>
<code data-trim data-noescape>
import re

patterns = ['Enterprise', 'Death Star']
phrase = "The Enterprise is the flagship of the Federation."

for pattern in patterns:
    print('Looking for "{}" in "{}": '.format(pattern, phrase))

    if re.search(pattern, phrase):
        print("found a match!")
    else:
        print("no match!")
</code>
						</pre>
						<pre>
<code data-trim data-noescape>
Looking for "Enterprise" in "The Enterprise is the flagship of the Federation.":
found a match!
Looking for "Death Star" in "The Enterprise is the flagship of the Federation.":
no match!																																																							
</code>
						</pre>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h4>Python re match example:</h4>
						<p style="font-size: 24px;">Python's re.match is similar to re.search. The main difference being that match searches only at the start of the string whereas search will apply the pattern to the entire string.</p>
						<pre>
<code data-trim data-noescape>
import re

text = "I turned myself into a pickle. I'm Pickle Riiiiick."
text2 = "I did not turn myself into a pickle.  I am not Pickle Riiiiick."

match = re.match("I turned myself", text)
match2 = re.match("I did not", text2)

if match == None:
    print('Could not find "{}" in "{}"'.format(match.re.pattern, match.string))
else:
    print('Found "{}" in "{}"'.format(match.re.pattern, match.string))

if match2 == None:
    print('Could not find "{}" in "{}"'.format(match2.re.pattern, match2.string))
else:
    print('Found "{}" in "{}"'.format(match2.re.pattern, match2.string))
                                                                                                                                                                                                                            
</code>
						</pre>
						<pre>
<code data-trim data-noescape>
Found "I turned myself" in "I turned myself into a pickle. I'm Pickle Riiiiick"
Found "I did not" in "I did not turn myself into a pickle.  I am not Pickle Riiiiick."
</code>
						</pre>
					</section>		
				</section>
				<section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h2>Additional Libraries and Modules</h2>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>A few:</h3>
						<ul>
							<li>sys, os, socket, glob, subprocess, hashlib, shutil, math, json</li>
							<li>struct</li>
							<li>3rd party</li>
							<li>Paramiko</li>
							<li>pip</li>
							<li>Hitchhikers Guide</li>
						</ul>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h4>Sys, OS and Subprocess</h4>
						<ul>
							<li><b>sys module</b> 
								<ul>
									<li style="font-size: 24px;">Contains system level info</li>
									<li style="font-size: 24px;">sys.path, sys.argv, sys.modules</li>
								</ul>
							</li>
							<li><b>os module</b> 
								<ul>
									<li style="font-size: 24px;">interact with the os dependent functionality</li>
									<li style="font-size: 24px;">os.path, os.walk, os.system, os.stat</li>
								</ul>
							</li>
							<li><b>subprocess module</b> 
								<ul>
									<li style="font-size: 24px;">spawn process, stdin/stdout</li>
									<li style="font-size: 24px;">subprocess.Popen()</li>
								</ul>
							</li>
						</ul>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h4>Hashlib</h4>
						<p style="font-size: 24px;">Hashlib implements a common interface to many different secure hash and message digest algorithms.</p>
						<pre>
<code data-trim data-noescape>
import hashlib

m = hashlib.md5()
m.update("password")
print(m.digest())
print(m.hexdigest())

x = hashlib.md5()
x.update("password")
print( m.digest())

if m.digest() == x.digest():
    print('access granted')
</code>
						</pre>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h4>Struct</h4>
						<p style="font-size: 24px;">Struct performs conversions between Python values and C structs represented as Python strings. This is mostly used in handling binary data in files and network connections. This will be used during Network Programming.</p>
						<pre>
<code data-trim data-noescape>
import struct

data = struct.pack('hh1', 1, 2)
print(data)

data = struct.unpack('hh1', data)
print(data)
</code>
						</pre>
					</section>		
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h4>JSON</h4>
						<p style="font-size: 24px;">JSON is a lightweight data interchange format inspired by JavaScript object literal syntax. JSON is used in a whole lot of applications and scenarios.</p>
						<pre>
<code data-trim data-noescape>
import json

# JSON to Python
json_string = '{"make": "Ford", "model": "Mustang"}'
parsed_json = json.loads(json_string)
print(parsed_json['make'])


# Python to JSON
json_d = {
    'make': 'Ford',
    'model': 'Mustang',
    'type': 'Pony',
    'colors': ['red', 'blue', 'white', 'yellow']
}

parsed_d = json.dumps(json_d)
print(parsed_d)
</code>
						</pre>
					</section>
                    <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
                        <h2>Labs</h2>
                        <a href="../lab_json_i.html">JSON Lab - Part I</a>
                        <a href="../lab_json_ii.html">JSON Lab - Part II</a>
                    </section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h4>Paramiko</h4>
						<p style="font-size: 24px;">Paramiko is a Python (2.7, 3.4+) implementation of SSHv2 protocol. Paramiko utilizes a Python C extension for low level crytography; though Paramiko itself utilizes a Python interface around SSH network concepts.</p>
						<a href="http://www.paramiko.org/">http://www.paramiko.org/</a>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h4>PIP</h4>
						<p style="font-size: 24px;">
							pip is a tool for installing Python packages. There is all sorts of packages you can install from Requests (http library) to Scrapy (webscraping).
							Since you have Python already installed, you have pip. Below is an example on how to install Requests.
						</p>
						<pre>
<code data-trim data-noescape>
pip install requests
</code>
						</pre>
						<p style="font-size: 24px;">
							Easy. Here is a great list of some of the most popular Python packages.
						</p>
						<a href="https://pythontips.com/2013/07/30/20-python-libraries-you-cant-live-without/">https://pythontips.com/2013/07/30/20-python-libraries-you-cant-live-without/</a>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h4>Pickling</h4>
						<p style="font-size: 24px;">
							Pickling is Python's way of serializing data. When you serialize data you're converting your object into a stream of bytes that you can save to a file for later use. 
							pickle is part of the Python standard library. In order to access the module you must import it.
						</p>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<pre>
<code data-trim data-noescape>
import pickle
</code>
						</pre>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p style="font-size: 24px;">
							You can pickle or serialize objects with the pick module, and you can also do the reverse which is known as unpickling, or deserializing the object.
						</p>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p>
							After you've imported the pickle module the typical process is as follows:
						</p>
						<ul>
							<li style="font-size: 24px;">Open a file for binary writing</li>
							<li style="font-size: 24px;">Call the dump method to pickle your object</li>
							<li style="font-size: 24px;">After pickling all objects you want, close the file</li>
						</ul>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p>
							You can pickle just about any type of object including:
						</p>
						<ul>
							<li style="font-size: 24px;">lists, tuples, dictionaries, sets</li>
							<li style="font-size: 24px;">strings, ints, and floats</li>
						</ul>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p>
							In order to pickle an object we can use the following methods:
						</p>
						<pre>
<code data-trim data-noescape>
pickle.dump(object, file)
pickle.dumps(object)
</code>
						</pre>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p>
							The difference between dump() and dumps() is that the dump method will take an argument for a file you want to write your serialized object to, 
							while the dumps method simply will return the pickled representation of the object as a bytes object. You can then later write it to a file if you so choose.
						</p>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p>
							In order to unpickle our object we can use the following methods:
						</p>
						<pre>
<code data-trim data-noescape>
pickle.load(inputfile)
pickle.loads(data)
</code>
						</pre>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p>
							The difference between load() and loads() is that the load method will read the pickled representation of an object from the open file object, 
							while the loads will return the representation of your data object.
						</p>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p>
							NOTE: Remember that the pickle module is not secure. Only unpickle data that you trust.
							It is possible to construct malicious pickle data which will execute arbitrary code during unpickling
						</p>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h4>The HitchHiker's Guide</h4>
						<p style="font-size: 24px;">
							The HitchHiker's guide is an excellent guide on Python that is constantly being updated.
						</p>
						<a href="http://docs.python-guide.org/en/latest/">http://docs.python-guide.org/en/latest/</a>
					</section>
				</section>
				<section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h2>Multithreading</h2>
					</section>
					<section>
					<h2>Concurrency versus parallelism</h2>
					<ul>
						<li>Concurrency is the ability to run multiple things at the same time, not necessarily in parallel.</li> 
						<li>Parallelism is the ability to do a number of things at the same time.</li>
					</ul>
					</section>
					<section>
						<h3>Modern Laptop processors feature multiple cores(normally 2 to 4).</h3>
						<ul>A core is an independent processing unit that belongs to a processor</ul>
					</section>
					<section>
						<h2>The concept of a thread</h2>
						<ul>a thread of execution is the smallest unit of programming commands (code) that a scheduler (usually as part of an operating system) can process and manage.</ul>
					</section>
					<section>
						<h2>Threads versus processes</h2>
					
					</section>
					<section>
						<h2>Multithreading</h2>
						<ul>multithreading implements more than one thread to exist and execute in a single process, simultaneously</ul>
					
					</section>
					<section>
						<h2>Advantages</h2>
						<ul>
							<li>Faster execution time</li>
							<li>Responsiveness</li>
							<li>Efficiency in resource consumption</li>
						</ul>
                        <h2>Disadvantages</h2>
						<ul>
							<li>Crashes</li>
							<li>Synchronization</li>
						</ul>
					
					</section>
					<section>
						<h2>Anatomy of a Thread</h2>
						<ul>
							<li>User-level threads: Threads that we can create and manage in order to perform a task</li>
							<li>Kernel-level threads: Low-level threads that run in kernel mode and act on behalf of the operating system</li>
					</section>
					<section>
						<h2>Thread states</h2>
						<ul>
						<li>New Thread</li>
						<li>Runnable</li>
						<li>Running</li>
						<li>Not-Running</li>
						<li>Dead</li>
						</ul>

					
					</section>
					<section>
						<h2>Context-switching</h2>
						<ul>We have said that the scheduler can decide when a thread can run, or is paused, and so on</ul>
					
					</section>
					<section>
						<h2>Global Interpreter Lock</h2>
						<ul>It is basically a mechanism in python which makes sure that there is never more than one thread of execution for the python interpreter at any given moment</ul>
					</section>
					<section>
						<h2>Race Conditions and Deadlocks</h2>
                        <ul>
                            <li> Race Condition: A race condition is a behavior of a system where the output of a procedure depends on the sequence or timing of other uncontrollable events</li>
                            <li> Locks</li>
                            <li> Deadlocks: A deadlock is a state in which each member of a group is waiting for some other member to take action, such as sending a message or, more commonly, releasing a lock, or a resource</ul></li>
                        </ul>
                    </section>
					<section>
						<h3>Functions from the Threading module</h3>
						<ul>
							<li>threading.activeCount()</li>
							<li>threading.currentThread()</li>
							<li>threading.enumerate()</li>
						</ul>
					</section>
					<section>
						<h3>Thread class</h3>
						<ul>
							<li>run()</li>
							<li>start()</li>
							<li>Join()</li>
							<li>isAlive()</li>
							<li>getName()</li>
							<li>setName()</li>

						</ul>
					
					</section>
					
					<section>
						<h3> Multithreading Demos</h3>
					
					</section>
					<section>
						<h3>Synchronizing Threads</h3>
						<ul>
							<li>threading.Lock()</li>
							<li>acquire()</li>
							<li>release()</li>
						</ul>
					
					</section>
					<section>
						<h3>RLock</h3>
						<ul>An RLock stands for a re-entrant lock. A re-entrant lock can be acquired multiple times by the same thread</ul>
					</section>
				
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p>Multithreading is similar to running multiple programs concurrently... but better.</p>
						<ul>
							<li style="font-size: 24px;">Threads within a process share the same data space with the main thread.</li>
							<li style="font-size: 24px;">Requires less memory overhead and is cheaper than running multiple processes</li>
						</ul>
						<p>A thread has a beginning, execution sequence and conclusion. An instruction pointer keeps track of where it is currently running.</p>
						<ul>
							<li style="font-size: 24px;">Threads can be put to sleep, even while other threads are running.</li>
							<li style="font-size: 24px;">Threads can also be pre-emptied (interrupted)</li>
						</ul>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h4>Multithreading Example:</h4>
						<pre>
<code data-trim data-noescape>
import time
from threading import Thread 

# Work to be done
def sleeper(i):
    print("thread {:d} sleeps for 5 seconds\n".format(i))
    time.sleep(5)
    print("thread {:d} woke up\n".format(i))

# Creating the workers, and passing individual arguments to each of them
for i in range(10):
    t = Thread(target=sleeper, args=(i,))
    t.start()
</code>
						</pre>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<pre>
<code data-trim data-noescape>
thread 0 sleeps for 5 seconds

thread 1 sleeps for 5 seconds
thread 2 sleeps for 5 seconds
thread 3 sleeps for 5 seconds

thread 4 sleeps for 5 seconds


thread 5 sleeps for 5 seconds


thread 6 sleeps for 5 seconds

thread 7 sleeps for 5 seconds
thread 8 sleeps for 5 seconds


thread 9 sleeps for 5 seconds

thread 9 woke up
thread 7 woke up
thread 6 woke up
thread 4 woke up
thread 2 woke up
thread 1 woke up
thread 8 woke up
thread 0 woke up
thread 5 woke up
thread 3 woke up																																																																													
</code>
						</pre>
						<p style="font-size: 24px;">Your output may not look like mine... that is okay. The time in which the workers start is almost always random due to how concurrent their launch sequences are.</p>
					</section>
                    <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
                        <h2>Labs</h2>
                        <a href="../multithreading_lab.md">Multithreading Lab</a>
                    </section>
				</section>
				<section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h2>Unit Testing</h2>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h4>UnitTesting</h4>
						<p>
							Unit testing is a development process where parts of small code (called units) are individually and independently tested for proper operation. This can of course be done manually... but it is more often automated. 
							This is an extremely important habit to build.
						</p>
						<p>
							Python offers a powerful built in unit testing module called unittest.
						</p>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h4>UnitTest Example:</h4>
						<pre>
<code data-trim data-noescape>
import unittest

def addx(x):
    return x + 1

class MyTest(unittest.TestCase):
    def test(self):
        # is addX(3) == 4?
        self.assertEqual(addx(3), 4)

# Run test on file launch
if __name__ == '__main__':
    unittest.main()																																																																																
</code>
						</pre>
						<ul>
							<li style="font-size: 24px;">Above, we define a function in which we want to test... a unit.</li>
							<li style="font-size: 24px;">Then we create a test class and make it a child of TestCase</li>
							<li style="font-size: 24px;">Then we call upon one of the many assert methods. (<a href="https://docs.python.org/3/library/unittest.html#assert-methods">https://docs.python.org/3/library/unittest.html#assert-methods</a>)</li>
						</ul>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p><b>Output:</b></p>
						<pre>
<code data-trim data-noescape>
----------------------------------------------------------------------
Ran 1 test in 0.001s

OK
</code>
						</pre>
					</section>	
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p>In our case, this is exactly what we want to see. But what happens if the test case fails? Let's pass in the argument 4 to addx and see.</p>
						<pre>
<code data-trim data-noescape>
F
======================================================================
FAIL: test (__main__.MyTest)
----------------------------------------------------------------------
Traceback (most recent call last):
    File ".\unit_testing.py", line 9, in test
    self.assertEqual(addx(4), 4)
AssertionError: 5 != 4

----------------------------------------------------------------------
Ran 1 test in 0.001s

FAILED (failures=1)
</code>
						</pre>
						<ul>
							<li style="font-size: 24px;">We get a nice fat F for failure</li>
							<li style="font-size: 24px;">Where the file failed</li>
							<li style="font-size: 24px;">The normal traceback</li>
							<li style="font-size: 24px;">The AssertionError which breaks down a more readable reason why it failed</li>
							<li style="font-size: 24px;">The runtime for each test</li>
							<li style="font-size: 24px;">And a FAILED status indicating how many failures.</li>
						</ul>
					</section>	
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h4>Doctest</h4>
						<p>The doctest module searches for sections of text that look like interactive Python sessions in docstrings, and then executes them to verify that they work.</p>
						<pre>
<code data-trim data-noescape>
def addition(x, y):
    """ Return x plus y

    >>> addition(3, 3)
    6
    >>> addition(5, 2)
    1
    """

    return x + y

if __name__ == '__main__':
    import doctest
    doctest.testmod()																																																																												
</code>
						</pre>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<pre>
<code data-trim data-noescape>
**********************************************************************
File ".\unit_testing.py", line 6, in __main__.addition
Failed example:
    addition(5, 2)
Expected:
    1
Got:
    7
**********************************************************************
1 items had failures:
    1 of   2 in __main__.addition
***Test Failed*** 1 failures.
PS C:\Users\xconstaud\Documents\Python\re>
                                                                                                                                                                                                                                                                                                                
</code>
						</pre>
						<h4>Conclusion</h4>
						<p style="font-size: 24px;">As you have guessed, this can be insanely useful. In most cases, spending the extra time unit testing will save you a lot more time over debugging.</p>
					</section>
				</section>
				<section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h2>Metaclasses</h2>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p><b>Defined as 'the class of a class'.</b></p>
						<ul>
							<li style="font-size: 24px;">Any class whose instances are themselves classes.</li>
							<li style="font-size: 24px;">type is a metaclass for instance; it creates classes!</li>
							<li style="font-size: 24px;">Used to construct classes. (always happens under hood)</li>
							<li style="font-size: 24px;">Can create dynamic classes with less lines using type.</li>
							<li style="font-size: 24px;">Think: instances are to classes as classes are to metaclasses.</li>
							<li style="font-size: 24px;">To create a metaclass, create a class that inherits from type</li>
						</ul>
						<pre>
<code data-trim data-noescape>
# in the most simple form
class Meta(type):
    pass
</code>
						</pre>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<ul>
							<li style="font-size: 24px;">Classes are normally created with the type metaclass</li>
							<li style="font-size: 24px;">We can create a class with a different metaclass:</li>
						</ul>
						<pre>
<code data-trim data-noescape>
# Python 3
class Final(metaclass=Meta):
    pass
</code>
						</pre>
						<p style="font-size: 24px; text-align: left;"><b>__new__():</b> It's a method which is called before __init__(). It creates the object and return it.</p>
						<p style="font-size: 24px; text-align: left"><b>__init__():</b> This method just initialize the created object passed as parameter</p>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p><b>Example:</b></p>
						<pre>
<code data-trim data-noescape>
class Meta(type):
    def __init__(cls, name, bases, dct):
        print("Creating class {} using Meta".format(name))
        super(Meta, cls).__init__(name, bases, dct)
class Foo(object, metaclass=Meta):
    __metaclass__ = Meta
class FooBar(Foo):
    pass
                                                                                                                                                                                                                                                                                                    
</code>
						</pre>
						<p style="font-size: 20px; text-align: left;">First we create a new metaclass called Meta:</p>
						<ul>
							<li style="font-size: 20px;">On the construction of classes built using Meta, we print out that we are creating a class using Meta.</li>
						</ul>
						<p style="font-size: 20px; text-align: left;">Next, create a class called Foo, built from Meta rather than type.</p>
						<p style="font-size: 20px; text-align: left;">Finally, create a FooBar class from Foo.</p>
						<ul>
							<li style="font-size: 20px;">Notice how it too was built using Meta?</li>
						</ul>
					</section>
				</section>
                <section>
                    <section>
                        <h2>Questions?</h2>
                    </section>
                    <section>
                        <h2>Summary</h2>
                        <ul>
                            <li>CTypes and Structures</li>
                            <li>Loading Libraries</li>
                            <li>Structures</li>
                            <li>Regular Expressions</li>
                            <li>Additional Libraries and Modules</li>
                            <li>Multithreading</li>
                            <li>Unit Testing</li>
                            <li>Metaclasses</li>
                        </ul>
                    </section>
                </section>
			</div>
		</div>
		<footer style="background:green; left:0; right:0; bottom: 0; position:absolute; height:30px;">
			<div style="text-align: center;">(U)Unclassified</div>
		</footer>		
		<script src="js/reveal.js"></script>

		<script>
			// More info about config & dependencies:
			// - https://github.com/hakimel/reveal.js#configuration
			// - https://github.com/hakimel/reveal.js#dependencies
			Reveal.initialize({
				hash: true,
				menu: {
					// Specifies which side of the presentation the menu will 
					// be shown. Use 'left' or 'right'.
					side: 'left',

					// Specifies the width of the menu.
					// Can be one of the following:
					// 'normal', 'wide', 'third', 'half', 'full', or
					// any valid css length value
					width: 'normal',

					// Add slide numbers to the titles in the slide list.
					// Use 'true' or format string (same as reveal.js slide numbers)
					numbers: true,

					// Specifies which slide elements will be used for generating
					// the slide titles in the menu. The default selects the first
					// heading element found in the slide, but you can specify any
					// valid css selector and the text from the first matching
					// element will be used.
					// Note: that a section data-menu-title attribute or an element
					// with a menu-title class will take precedence over this option
					titleSelector: 'h1, h2, h3, h4, h5, h6',

					// If slides do not have a matching title, attempt to use the
					// start of the text content as the title instead
					useTextContentForMissingTitles: false,

					// Hide slides from the menu that do not have a title.
					// Set to 'true' to only list slides with titles.
					hideMissingTitles: false,

					// Adds markers to the slide titles to indicate the 
					// progress through the presentation. Set to 'false'
					// to hide the markers.
					markers: true,

					// Specify custom panels to be included in the menu, by
					// providing an array of objects with 'title', 'icon'
					// properties, and either a 'src' or 'content' property.
					custom: false,

					// Specifies the themes that will be available in the themes
					// menu panel. Set to 'true' to show the themes menu panel
					// with the default themes list. Alternatively, provide an
					// array to specify the themes to make available in the
					// themes menu panel, for example...
					// [
					//     { name: 'Black', theme: 'css/theme/black.css' },
					//     { name: 'White', theme: 'css/theme/white.css' },
					//     { name: 'League', theme: 'css/theme/league.css' }
					// ]
					themes: true,

					// Specifies the path to the default theme files. If your
					// presentation uses a different path to the standard reveal
					// layout then you need to provide this option, but only
					// when 'themes' is set to 'true'. If you provide your own 
					// list of themes or 'themes' is set to 'false' the 
					// 'themesPath' option is ignored.
					themesPath: 'css/theme/',

					// Specifies if the transitions menu panel will be shown.
					// Set to 'true' to show the transitions menu panel with
					// the default transitions list. Alternatively, provide an
					// array to specify the transitions to make available in
					// the transitions panel, for example...
					// ['None', 'Fade', 'Slide']
					transitions: true,

					// Adds a menu button to the slides to open the menu panel.
					// Set to 'false' to hide the button.
					openButton: true,

					// If 'true' allows the slide number in the presentation to
					// open the menu panel. The reveal.js slideNumber option must 
					// be displayed for this to take effect
					openSlideNumber: true,

					// If true allows the user to open and navigate the menu using
					// the keyboard. Standard keyboard interaction with reveal
					// will be disabled while the menu is open.
					keyboard: true,

					// Normally the menu will close on user actions such as
					// selecting a menu item, or clicking the presentation area.
					// If 'true', the sticky option will leave the menu open
					// until it is explicitly closed, that is, using the close
					// button or pressing the ESC or m key (when the keyboard 
					// interaction option is enabled).
					sticky: true,

					// If 'true' standard menu items will be automatically opened
					// when navigating using the keyboard. Note: this only takes 
					// effect when both the 'keyboard' and 'sticky' options are enabled.
					autoOpen: true,

					// If 'true' the menu will not be created until it is explicitly
					// requested by calling RevealMenu.init(). Note this will delay
					// the creation of all menu panels, including custom panels, and
					// the menu button.
					delayInit: false,

					// If 'true' the menu will be shown when the menu is initialised.
					openOnInit: false,

					// By default the menu will load it's own font-awesome library
					// icons. If your presentation needs to load a different
					// font-awesome library the 'loadIcons' option can be set to false
					// and the menu will not attempt to load the font-awesome library.
					loadIcons: true
				},
				dependencies: [
					{ src: 'plugin/markdown/marked.js' },
					{ src: 'plugin/markdown/markdown.js' },
					{ src: 'plugin/highlight/highlight.js' },
					{ src: 'plugin/notes/notes.js', async: true },
					{ src: 'plugin/reveal.js-menu/menu.js' }
				]
			});
		</script>
	</body>
</html>
